#NoEnv
#SingleInstance, Force

Gui, New, -MinimizeBox, Realsize

HBM := LoadPicture(A_AhkPath)
HBITMAP := "HBITMAP:*" . HBM ;  Use * when you don't want Imagen() to delete HBM

; In the following 3 examples Image dimensions are = Control dimensions.
; The background of image matches the Window color so the effect isn't visible

Imagen(HBITMAP, "W100 H75", HBM1)              ; HBM is stretched to fit 100x75
Gui, Add, Picture, w100 h75 Border HwndhPic1
GuiControl,, %hPic1%, *w0 *h0 HBITMAP:%HBM1%

Imagen(HBITMAP, "W100 H75 Scale", HBM2)        ; Creates 100x75 bitmap, downscales HBM (if neccessary), and pastes HBM in center
Gui, Add, Picture, w100 h75 Border HwndhPic2
GuiControl,, %hPic2%, *w0 *h0 HBITMAP:%HBM2%

Imagen(HBITMAP, "W100 H75 Upscale", HBM3)      ; Creates 100x75 bitmap, upscales HBM to 75x75 and pastes it in center
Gui, Add, Picture, w100 h75 Border HwndhPic3
GuiControl,, %hPic3%, *w0 *h0 HBITMAP:%HBM3%

; Effect of Realsize when specified in Imagen(, Options)
; Note: Realsize will be ignored when ahk_id is specified in Options.

; Control will resize to fit the size of image
Imagen(HBITMAP, "W100 H75 Scale Realsize", HBM4)
Gui, Add, Picture, w100 h75 Border HwndhPic4
GuiControl,, %hPic4%, *w0 *h0 HBITMAP:%HBM4%

; Control will not resize when SS_CENTERIMAGE is used
Imagen(HBITMAP, "W100 H75 Scale Realsize", HBM5)   ; Downscales HBM if needed
Gui, Add, Picture, w100 h75 Border HwndhPic5 0x200 ; SS_CENTERIMAGE := 0x200
GuiControl,, %hPic5%, *w0 *h0 HBITMAP:%HBM5%

; Control will not resize when SS_CENTERIMAGE is used
Imagen(HBITMAP, "W100 H75 Upscale Realsize", HBM6) ; Upscales HBM to fit control
Gui, Add, Picture, w100 h75 Border HwndhPic6 0x200 ; SS_CENTERIMAGE := 0x200
GuiControl,, %hPic6%, *w0 *h0 HBITMAP:%HBM6%

Gui, Show
