#NoEnv
#Warn
#SingleInstance, Force
SetWorkingDir, %A_ScriptDir%
SetBatchLines, -1

CBM := 0, HBM1 := 0, HBM2 := 0
Menu, OptionMenu, Add, &Open Image`tCtrl+O, SelectFile
Menu, OptionMenu, Add, &Apply`tCtrl+Enter, Apply
Menu, OptionMenu, Add, &Toggle effect`tCtrl+T, ToggleFx
Menu, OptionMenu, Add, Copy &Hex`tCtrl+H, CopyToClipboard
Menu, OptionMenu, Add
Menu, OptionMenu, Add, &Grayscale`tCtrl+G, Presets
Menu, OptionMenu, Add, &Invert`tCtrl+I, Presets
Menu, OptionMenu, Add, Se&pia`tCtrl+P, Presets
Menu, OptionMenu, Add, &Reset`tCtrl+R, Reset
Menu, OptionMenu, Add
Menu, OptionMenu, Add, E&xit`tCtrl+W, CmGuiClose
Menu, CMMenu, Add, &Options, :OptionMenu

Gui, Cm:New, -MinimizeBox, ColorMatrix Tester
Gui, Menu, CMMenu
Gui, Margin, 10, 4
Gui, Add, Picture, xm ym+6 w200 h360 Border 0x200 hWndhPic gSelectFile
Gui, Font, s10, Consolas
Gui, Add, Edit, Section -E0x200 Center Disabled, % Format("{:8}", "")

Gui, Font, Q5, Segoe UI
Loop, Parse, % "Red,Green,Blue,Alpha,White",  CSV
 Gui, Add, Text, wp hp ys Section Center 0x200, %A_LoopField%

Loop, Parse, % "Red,Green,Blue,Alpha,White",  CSV
{
    Gui, Add, Text, wp hp xm Section 0x200, %A_LoopField%
    Loop 5
        Gui, Add, Edit, % "wp hp ys Center" . (A_Index=5 ? " ReadOnly -Tabstop" : "")
}

GuiControlGet, Z, Pos, Edit6
GuiControl, Move, Static1,  % "w" . (ZX+ZW-10)

Gui, Margin, 10, 10
Gui, Add, Link, xm -Tabstop,  % "Refer <a href=""https://docs.rainmeter.net/tips/colormatrix-guide/"
 . """>ColorMatrix Guide</a> for matrix values`nImages courtesy of <a href=""https://picsum.photos/"
 . """>Lorem Picsum</a>"
Gui, Add, Button, x%ZX% yp w%ZW% hp Default -Tabstop gApply, &Apply

VarSetCapacity(RECT,16)
DllCall("GetClientRect", "Ptr",hPic, "Ptr",&RECT)
W := NumGet(RECT, 8, "Int") - NumGet(RECT, 0, "Int")
H := NumGet(RECT,12, "Int") - NumGet(RECT, 4, "Int")

Loop, Parse, % ",1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1", CSV
  GuiControl, CM:, Edit%A_Index%, %A_LoopField%

If FileExist( ImgFile := "Images\Img_0076.jpg")
  GoSub, LoadImage
Gui, Show
Return                                                                 ; end of auto-execute section


Reset:
  Loop, Parse, % ",1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1", CSV
    GuiControl, CM:, Edit%A_Index%, %A_LoopField%

  GuiControl,, %hPic%, *w0 *h0 HBITMAP:*%HBM1%
  DllCall("DeleteObject", "Ptr",HBM2), HBM2 := 0
  CBM := 1
Return

Apply:
  If (! HBM1)
      Return

  GoSub, ColorMatrixHex
  Options := Format("?{1:} W{2:} H{3:} Scale Realsize Background000000", RTrim(Hex, "`r`n"), W, H)
  DllCall("DeleteObject", "Ptr",HBM2)
  Imagen("HBITMAP:*" . HBM1, Options, HBM2), CBM := 2
  GuiControl,, %hPic%, *w0 *h0 HBITMAP:*%HBM2%
Return                                                               

SelectFile:
  Gui, Cm: +OwnDialogs
  FileSelectFile, ImgFile,, %A_ScriptDir%\Images, Select image, Images (*.jpg;*.png;*.bmp)
  If (ErrorLevel)
      Return
LoadImage:
  Options := Format("W{:d} H{:d} Scale Realsize Background000000", W, H)
  Imagen(ImgFile, Options, HBM)
  If (! HBM)
    Return
  DllCall("DeleteObject", "Ptr",HBM1)
  DllCall("DeleteObject", "Ptr",HBM2), HBM2 := 0,   HBM1 := HBM
  GoSub, Reset
Return

ColorMatrixHex:
  VarSetCapacity(Hex, 406, 0), VarSetCapacity(CM, 100, 0), pCM := &CM
  Loop 25
  {
      NN := A_Index+1
      GuiControlGet, Num,, Edit%NN%
      pCM := NumPut(Num, pCM+0, "Float")
  }
  DllCall("Crypt32.dll\CryptBinaryToString", "Ptr",&CM, "Int",100, "Int",0xC, "Str",Hex, "IntP",203)
Return

ToggleFx:
  If ( HBM1=0 || HBM2=0 )
      Return

  If (CBM=1 && (CBM:=2))
      GuiControl,, %hPic%, *w0 *h0 HBITMAP:*%HBM2%
  Else If (CBM=2 && (CBM:=1))
      GuiControl,, %hPic%, *w0 *h0 HBITMAP:*%HBM1%
Return

CopyToClipboard:
  If ! (CBM=2)
      Return

  GoSub, ColorMatrixHex
  Clipboard := Hex
  SoundBeep, 1000,10
Return

Presets:
  If ( HBM1=0 )
      Return
  ThisMenuItem := StrSplit(A_ThisMenuItem, A_Tab)[1]

  If (ThisMenuItem="&Grayscale")
  Loop, Parse
   , % ",0.299,0.299,0.299,0,0,0.587,0.587,0.587,0,0,0.114,0.114,0.114,0,0,0,0,0,1,0,0,0,0,0,1", CSV
   GuiControl, CM:, Edit%A_Index%, %A_LoopField%

  If (ThisMenuItem="&Invert")
  Loop, Parse, % ",-1,0,0,0,0,0,-1,0,0,0,0,0,-1,0,0,0,0,0,1,0,1,1,1,0,1", CSV
   GuiControl, CM:, Edit%A_Index%, %A_LoopField%

  If (ThisMenuItem="Se&pia")
  Loop, Parse
   , % ",0.393,0.349,0.272,0,0,0.769,0.686,0.534,0,0,0.189,0.168,0.131,0,0,0,0,0,1,0,0,0,0,0,1", CSV
   GuiControl, CM:, Edit%A_Index%, %A_LoopField%
  GoSub, Apply
Return

CmGuiEscape:
CmGuiClose:
  ExitApp